@misc{minas_problem_2009,
	title = {The {Problem} of {Power} {Consumption} in {Servers} {\textbar} {Intel}® {Software}},
	url = {https://software.intel.com/en-us/articles/the-problem-of-power-consumption-in-servers/},
	urldate = {2017-04-27},
	author = {Minas, Lauri and Ellison, Brad},
	year = {2009}
}

@inproceedings{wallace_measuring_2013,
	title = {Measuring {Power} {Consumption} on {IBM} {Blue} {Gene}/{Q}},
	doi = {10.1109/IPDPSW.2013.269},
	booktitle = {2013 {IEEE} {International} {Symposium} on {Parallel} {Distributed} {Processing}, {Workshops} and {Phd} {Forum}},
	author = {Wallace, S. and Vishwanath, V. and Coghlan, S. and Lan, Z. and Papka, M. E.},
	month = may,
	year = {2013},
	pages = {853--859}
}

@inproceedings{david_memory_2011,
	address = {New York, NY, USA},
	series = {{ICAC} '11},
	title = {Memory {Power} {Management} via {Dynamic} {Voltage}/{Frequency} {Scaling}},
	isbn = {978-1-4503-0607-2},
	url = {http://doi.acm.org/10.1145/1998582.1998590},
	doi = {10.1145/1998582.1998590},
	urldate = {2017-04-27},
	booktitle = {Proceedings of the 8th {ACM} {International} {Conference} on {Autonomic} {Computing}},
	publisher = {ACM},
	author = {David, Howard and Fallin, Chris and Gorbatov, Eugene and Hanebutte, Ulf R. and Mutlu, Onur},
	year = {2011},
	pages = {31--40}
}

@article{lefurgy_energy_2003,
	title = {Energy management for commercial servers},
	volume = {36},
	issn = {0018-9162},
	url = {http://ieeexplore.ieee.org/document/1250880/},
	doi = {10.1109/MC.2003.1250880},
	language = {en},
	number = {12},
	urldate = {2017-09-22},
	journal = {Computer},
	author = {Lefurgy, C. and Rajamani, K. and Rawson, F. and Felter, W. and Kistler, M. and Keller, T.W.},
	month = dec,
	year = {2003},
	pages = {39--48}
}

@book{barroso_datacenter_2009,
	address = {San Rafael, Calif.},
	series = {Synthesis lecture om computer architecture},
	title = {The datacenter as a computer: an introduction to the design of warehouse-scale machines},
	isbn = {978-1-59829-556-6 978-1-59829-557-3},
	shorttitle = {The datacenter as a computer},
	language = {eng},
	number = {6},
	publisher = {Morgan \& Claypool},
	author = {Barroso, Luiz André and Hölzle, Urs},
	year = {2009},
	note = {OCLC: 695904058}
}

@techreport{peyman_blumstengel_leveraging_2010,
	title = {Leveraging memory technology to cut data center power consumption},
	url = {http://www.samsung.com/global/business/semiconductor/file/product/Whitepaper_30nmvs50nm_V21_November_2010-0.pdf},
	urldate = {2017-04-27},
	author = {{Peyman Blumstengel} and {Simon Jordan} and {Alfred Richter (TUV Rheinland)} and {Susanne Brügelmann} and {Jürgen Häckel} and {Dieter Gottschling} and {Hansfried Block (Fujitsu)} and {Frank Koch \& Michael Korp (Microsoft)} and {Gerold Würthmann} and {Ulrich Norf (Intel)}},
	month = dec,
	year = {2010}
}

@misc{laudon_ultrasparc_2006,
	title = {{UltraSPARC} {T}1: {A} 32-threaded  {CMP} for {Servers}},
	url = {https://www.cs.umd.edu/users/meesh/webpages/cmsc411/CS252%20Lectures%20and%20Notes/17%20UltraSPARC%20T1%20A%2032-threaded%20CMP%20for%20Servers/Berkeley_CMP_presentation.pdf},
	author = {Laudon, James},
	month = sep,
	year = {2006}
}

@misc{melendez_need_2015,
	title = {A {Need} to {Reduce} {Data} {Center} {Power} {Consumption}},
	url = {https://www.linkedin.com/pulse/need-reduce-data-center-power-consumption-john-mel%C3%A9ndez-%E9%A6%AC%E5%BC%B7%E5%AE%89},
	author = {Meléndez, John},
	month = apr,
	year = {2015}
}

@book{darche_architecture_2011,
	title = {Architecture des ordinateurs-{Mémoires} à semi-conducteurs : {Principe} de fonctionnement et organisation interne des mémoires vives},
	volume = {1},
	shorttitle = {Architecture des ordinateurs-{Mémoires} à semi-conducteurs},
	url = {https://hal.archives-ouvertes.fr/hal-01288053},
	urldate = {2017-04-29},
	publisher = {Editions Vuibert},
	author = {Darche, Philippe},
	year = {2011}
}

@book{jacob_memory_2007,
	address = {San Francisco, CA, USA},
	title = {Memory {Systems}: {Cache}, {DRAM}, {Disk}},
	isbn = {978-0-12-379751-3},
	shorttitle = {Memory {Systems}},
	publisher = {Morgan Kaufmann Publishers Inc.},
	author = {Jacob, Bruce and Ng, Spencer and Wang, David},
	year = {2007}
}

@techreport{jedec_ddr3_2012,
	title = {{DDR}3 {SDRAM} {SWDQGDUG}},
	number = {JESD79-3F},
	author = {{JEDEC}},
	month = jul,
	year = {2012}
}

@techreport{jedec_ddr4_2016,
	title = {{DDR}4 {SDRAM} {UDIMM} {Design} {Specification}},
	number = {JEDEC Standard No. 21C},
	author = {{JEDEC}},
	month = jun,
	year = {2016}
}

@inproceedings{liu_raidr_2012,
	address = {Portland, OR, USA},
	title = {{RAIDR}: {Retention}-aware intelligent {DRAM} refresh},
	isbn = {978-1-4673-0476-4 978-1-4673-0475-7 978-1-4673-0473-3 978-1-4673-0474-0},
	shorttitle = {{RAIDR}},
	url = {http://ieeexplore.ieee.org/document/6237001/},
	doi = {10.1109/ISCA.2012.6237001},
	urldate = {2018-09-26},
	booktitle = {2012 39th {Annual} {International} {Symposium} on {Computer} {Architecture} ({ISCA})},
	publisher = {IEEE},
	author = {Liu, Jamie and Jaiyen, Ben and Veras, Richard and Mutlu, Onur},
	month = jun,
	year = {2012},
	pages = {1--12}
}

@article{bhati_dram_2016,
	title = {{DRAM} {Refresh} {Mechanisms}, {Penalties}, and {Trade}-{Offs}},
	volume = {65},
	issn = {0018-9340},
	url = {http://ieeexplore.ieee.org/document/7070756/},
	doi = {10.1109/TC.2015.2417540},
	number = {1},
	urldate = {2018-06-01},
	journal = {IEEE Transactions on Computers},
	author = {Bhati, Ishwar and Chang, Mu-Tien and Chishti, Zeshan and Lu, Shih-Lien and Jacob, Bruce},
	month = jan,
	year = {2016},
	pages = {108--121}
}

@article{suzuki_non-volatile_2011,
	title = {The non-volatile memory technology database (nvmdb)},
	volume = {296},
	url = {http://cseweb.ucsd.edu/~swanson/papers/TR2015-NVMDB.pdf},
	urldate = {2017-03-16},
	journal = {Micron},
	author = {Suzuki, Kosuke and Swanson, Steven},
	year = {2011},
	pages = {297},
	file = {NVMDB_v1-0_release.bib:/home/francis/.zotero/zotero/0cj1dqaw.default/zotero/storage/PG26AME5/NVMDB_v1-0_release.bib:text/x-bibtex;NVMDB_v1-0_release.xlsx:/home/francis/.zotero/zotero/0cj1dqaw.default/zotero/storage/VXISGSGT/NVMDB_v1-0_release.xlsx:application/vnd.openxmlformats-officedocument.spreadsheetml.sheet}
}

@techreport{intel_intel_2009,
	title = {Intel® {Core}™ i7-800/i5-700 {Desktop} {Processors}: {Datasheet}, {Vol}. 2},
	url = {http://www.csit-sun.pub.ro/~cpop/Documentatie_SMP/Intel_Microprocessor_Systems/Intel_ProcessorNew/Intel%20i7-i5-i3%20processors/Intel%20Core%20i7-800%20i5-700%20Dektop%20Processor%20Series%20vol2.pdf},
	author = {{Intel}},
	month = sep,
	year = {2009}
}

@misc{wiki_k8,
	author = {{Wikipedia contributors}},
	title = {AMD K8 --- {Wikipedia}{,} The Free Encyclopedia},
	year = {2018},
	url = {https://en.wikipedia.org/w/index.php?title=AMD_K8&oldid=840617401},
	note = {[Online; accessed 15-October-2018]}
}

@misc{wiki_nehalem,
	author = {{Wikipedia contributors}},
	title = {Nehalem (microarchitecture) --- {Wikipedia}{,} The Free Encyclopedia},
	year = {2018},
	url = {https://en.wikipedia.org/w/index.php?title=Nehalem_(microarchitecture)&oldid=863470340},
	note = {[Online; accessed 15-October-2018]}
}

@inproceedings{jung_reverse_2016,
	title = {Reverse {Engineering} of {DRAMs}: {Row} {Hammer} with {Crosshair}},
	isbn = {978-1-4503-4305-3},
	shorttitle = {Reverse {Engineering} of {DRAMs}},
	url = {http://dl.acm.org/citation.cfm?doid=2989081.2989114},
	doi = {10.1145/2989081.2989114},
	language = {en},
	urldate = {2017-04-13},
	publisher = {ACM Press},
	author = {Jung, Matthias and Rheinländer, Carl C. and Weis, Christian and Wehn, Norbert},
	year = {2016},
	pages = {471--476}
}

@techreport{hillenbrand_marius_physical_2017,
	title = {Physical {Address} {Decoding} in {Intel} {Xeon} v3/v4 {CPUs}: {A} {Supplemental} {Datasheet}},
	url = {https://publikationen.bibliothek.kit.edu/1000073678},
	author = {Hillenbrand, Marius},
	year = {2017}
}

@inproceedings{hassan_reverse-engineering_2015,
	title = {Reverse-engineering embedded memory controllers through latency-based analysis},
	isbn = {978-1-4799-8603-3},
	url = {http://ieeexplore.ieee.org/document/7108453/},
	doi = {10.1109/RTAS.2015.7108453},
	urldate = {2018-04-02},
	publisher = {IEEE},
	author = {Hassan, Mohamed and Kaushik, Anirudh M. and Patel, Hiren},
	month = apr,
	year = {2015},
	pages = {297--306}
}

@inproceedings{yun_palloc_2014,
	title = {{PALLOC}: {DRAM} bank-aware memory allocator for performance isolation on multicore platforms},
	isbn = {978-1-4799-4829-1 978-1-4799-4691-4},
	shorttitle = {{PALLOC}},
	url = {http://ieeexplore.ieee.org/document/6925999/},
	doi = {10.1109/RTAS.2014.6925999},
	urldate = {2018-07-23},
	publisher = {IEEE},
	author = {Yun, Heechul and Mancuso, Renato and Wu, Zheng-Pei and Pellizzoni, Rodolfo},
	month = apr,
	year = {2014},
	pages = {155--166}
}

@inproceedings{bailey_operating_2011,
	title = {Operating {System} {Implications} of {Fast}, {Cheap}, {Non}-{Volatile} {Memory}.},
	volume = {13},
	url = {http://static.usenix.org/event/hotos11/tech/final_files/Bailey.pdf},
	urldate = {2017-03-29},
	booktitle = {{HotOS}},
	author = {Bailey, Katelin and Ceze, Luis and Gribble, Steven D. and Levy, Henry M.},
	year = {2011},
	pages = {2--2}
}

@inproceedings{cho_0.18_2004,
	title = {A 0.18 mu;m 3.0 {V} 64 {Mb} non-volatile phase-transition random-access memory ({PRAM})},
	doi = {10.1109/ISSCC.2004.1332583},
	booktitle = {2004 {IEEE} {International} {Solid}-{State} {Circuits} {Conference} ({IEEE} {Cat}. {No}.04CH37519)},
	author = {Cho, Woo Yeong and Cho, Beak-hyung and Choi, Byung-gil and Oh, Hyung-rok and Kang, Sang-beom and Kim, Ki-sung and Kim, Kyung-hee and Kim, Du-eung and Kwak, Choong-keun and Byun, Hyun-geun and Hwang, Young-nam and Ahn, Su-jin and Jung, Gi-tae and Jung, Hong-sik and Kim, Kinam},
	month = feb,
	year = {2004},
	pages = {40--512 Vol.1}
}

@inproceedings{tsuchida_64mb_2010,
	title = {A 64Mb {MRAM} with clamped-reference and adequate-reference schemes},
	doi = {10.1109/ISSCC.2010.5433948},
	booktitle = {2010 {IEEE} {International} {Solid}-{State} {Circuits} {Conference} - ({ISSCC})},
	author = {Tsuchida, K. and Inaba, T. and Fujita, K. and Ueda, Y. and Shimizu, T. and Asao, Y. and Kajiyama, T. and Iwayama, M. and Sugiura, K. and Ikegawa, S. and Kishi, T. and Kai, T. and Amano, M. and Shimomura, N. and Yoda, H. and Watanabe, Y.},
	month = feb,
	year = {2010},
	pages = {258--259}
}

@inproceedings{womack_16_1989,
	title = {A 16 kb ferroelectric nonvolatile memory with a bit parallel architecture},
	doi = {10.1109/ISSCC.1989.48273},
	booktitle = {{IEEE} {International} {Solid}-{State} {Circuits} {Conference}, 1989 {ISSCC}. {Digest} of {Technical} {Papers}},
	author = {Womack, R. and Tolsch, D.},
	month = feb,
	year = {1989},
	pages = {242--243}
}

@inproceedings{chang_19.4_2014,
	title = {19.4 embedded 1Mb {ReRAM} in 28nm {CMOS} with 0.27-to-1V read using swing-sample-and-couple sense amplifier and self-boost-write-termination scheme},
	doi = {10.1109/ISSCC.2014.6757457},
	booktitle = {2014 {IEEE} {International} {Solid}-{State} {Circuits} {Conference} {Digest} of {Technical} {Papers} ({ISSCC})},
	author = {Chang, M. F. and Wu, J. J. and Chien, T. F. and Liu, Y. C. and Yang, T. C. and Shen, W. C. and King, Y. C. and Lin, C. J. and Lin, K. F. and Chih, Y. D. and Natarajan, S. and Chang, J.},
	month = feb,
	year = {2014},
	pages = {332--333}
}

@article{rizzo_fully_2013,
	title = {A {Fully} {Functional} 64 {Mb} {DDR}3 {ST}-{MRAM} {Built} on 90 nm {CMOS} {Technology}},
	volume = {49},
	issn = {0018-9464},
	doi = {10.1109/TMAG.2013.2243133},
	number = {7},
	journal = {IEEE Transactions on Magnetics},
	author = {Rizzo, N. D. and Houssameddine, D. and Janesky, J. and Whig, R. and Mancoff, F. B. and Schneider, M. L. and DeHerrera, M. and Sun, J. J. and Nagel, K. and Deshpande, S. and Chia, H. J. and Alam, S. M. and Andre, T. and Aggarwal, S. and Slaughter, J. M.},
	month = jul,
	year = {2013},
	pages = {4441--4446}
}

@inproceedings{lee_highly_2011,
	title = {Highly productive {PCRAM} technology platform and full chip operation: {Based} on 4F2 (84nm pitch) cell scheme for 1 {Gb} and beyond},
	shorttitle = {Highly productive {PCRAM} technology platform and full chip operation},
	doi = {10.1109/IEDM.2011.6131480},
	abstract = {We successfully developed highly scalable and cost-effective PCRAM technology based on 0.007um2 (4F2, 84nm pitch) sized novel cell scheme. The chip size and density are 33.207mm2 and 1Gb. The device functionality and reliability were clearly demonstrated through fully integrated chip, which showed a promising feasibility for productive NVM applications.},
	booktitle = {2011 {International} {Electron} {Devices} {Meeting}},
	author = {Lee, S. H. and Park, H. C. and Kim, M. S. and Kim, H. W. and Choi, M. R. and Lee, H. G. and Seo, J. W. and Kim, S. C. and Kim, S. G. and Hong, S. B. and Lee, S. Y. and Lee, J. U. and Kim, Y. S. and Kim, K. S. and Kim, J. I. and Lee, M. Y. and Shin, H. S. and Chae, S. J. and Song, J. H. and Yoon, H. S. and Oh, J. M. and Min, S. K. and Lee, H. M. and Hong, K. R. and Cheong, J. T. and Park, S. N. and Ku, J. C. and Sohn, Y. S. and Park, S. K. and Kim, T. S. and Kim, Y. K. and Park, K. W. and Han, C. S. and Kim, W. and Kim, H. J. and Choi, K. S. and Lee, J. H. and Hong, S. J.},
	month = dec,
	year = {2011},
	pages = {3.3.1--3.3.4}
}

@inproceedings{slaughter_high_2012,
	title = {High density {ST}-{MRAM} technology ({Invited})},
	doi = {10.1109/IEDM.2012.6479128},
	abstract = {We review key properties for commercial ST-MRAM circuits, discuss the challenges to achieving the many performance and scaling goals that are being addressed in current development around the world, recent results in the field, and present first results from a new, fully-functional 64Mb, DDR3, ST-MRAM circuit.},
	booktitle = {2012 {International} {Electron} {Devices} {Meeting}},
	author = {Slaughter, J. M. and Rizzo, N. D. and Janesky, J. and Whig, R. and Mancoff, F. B. and Houssameddine, D. and Sun, J. J. and Aggarwal, S. and Nagel, K. and Deshpande, S. and Alam, S. M. and Andre, T. and LoPresti, P.},
	month = dec,
	year = {2012},
	pages = {29.3.1--29.3.4}
}

@inproceedings{kim_ultrathin_2012,
	title = {Ultrathin ( {\textless} 10nm) {Nb}2O5/{NbO}2 hybrid memory with both memory and selector characteristics for high density 3D vertically stackable {RRAM} applications},
	doi = {10.1109/VLSIT.2012.6242508},
	abstract = {We report, for the first time, the novel concept of ultrathin ( 10nm) W/NbOx/Pt device with both threshold switching (TS) and memory switching (MS) characteristics. Excellent TS characteristics of NbO2, such as high temperature stability ( 160°C), fast switching speed ( 22ns), good switching uniformity, and extreme scalability of device area (φ 10nm)/thickness ( 10nm) were obtained. By oxidizing NbO2, we can form ultrathin Nb2O5/NbO2 stack layer for hybrid memory devices with both TS and MS. Without additional selector device, 1Kb cross-point hybrid memory device without SET/RESET disturbance up to 106 cycles was demonstrated.},
	booktitle = {2012 {Symposium} on {VLSI} {Technology} ({VLSIT})},
	author = {Kim, S. and Liu, X. and Park, J. and Jung, S. and Lee, W. and Woo, J. and Shin, J. and Choi, G. and Cho, C. and Park, S. and Lee, D. and Cha, E. j and Lee, B. H. and Lee, H. D. and Kim, S. G. and Chung, S. and Hwang, H.},
	month = jun,
	year = {2012},
	pages = {155--156}
}

@inproceedings{hanzawa_512kb_2007,
	title = {A 512kB {Embedded} {Phase} {Change} {Memory} with 416kB/s {Write} {Throughput} at 100 \#x003BC;{A} {Cell} {Write} {Current}},
	doi = {10.1109/ISSCC.2007.373500},
	abstract = {An experimental 512kB embedded PCM uses a current-saving architecture in a 0.13μm 1.5V CMOS. The write scheme features a low-write-current resistive device and achieves 416kB/s write-throughput at 100muA cell current. A charge-transfer direct-sense scheme has a 16b parallel read access time of 9.9ns in an array drawing 280μA. A standby voltage scheme suppresses leakage current in the cell current path and increases the measured PCM cell resistance from 3 to 33MΩ.},
	booktitle = {2007 {IEEE} {International} {Solid}-{State} {Circuits} {Conference}. {Digest} of {Technical} {Papers}},
	author = {Hanzawa, S. and Kitai, N. and Osada, K. and Kotabe, A. and Matsui, Y. and Matsuzaki, N. and Takaura, N. and Moniwa, M. and Kawahara, T.},
	month = feb,
	year = {2007},
	pages = {474--616}
}

@book{akel_onyx_2011,
	title = {Onyx: {A} {Protoype} {Phase} {Change} {Memory} {Storage} {Array}},
	author = {Akel, Ameen and Caulfield, Adrian and I. Mollov, Todor and Gupta, Rajesh and Swanson, Steven},
	month = jun,
	year = {2011}
}

@misc{itrs_2011chapters_2011,
	title = {2011Chapters},
	url = {https://www.dropbox.com/sh/r51qrus06k6ehrc/AACQYSRnTdLGUCDZFhB6_iXua/2011Chapters?dl=0},
	abstract = {Shared with Dropbox},
	urldate = {2017-03-15},
	journal = {Dropbox},
	author = {{ITRS}},
	year = {2011}
}

@misc{itrs_2013erd.pdf_2013,
	title = {2013ERD.pdf},
	url = {https://www.dropbox.com/sh/6xq737bg6pww9gq/AAAXRzGlUis1sVUxurZnMCY4a/2013ERD.pdf?dl=0},
	abstract = {Shared with Dropbox},
	urldate = {2017-03-17},
	journal = {Dropbox},
	author = {{ITRS}},
	year = {2013}
}

@article{apalkov_magnetoresistive_2016,
	title = {Magnetoresistive {Random} {Access} {Memory}},
	volume = {104},
	issn = {0018-9219},
	doi = {10.1109/JPROC.2016.2590142},
	number = {10},
	journal = {Proceedings of the IEEE},
	author = {Apalkov, D. and Dieny, B. and Slaughter, J. M.},
	month = oct,
	year = {2016},
	pages = {1796--1830}
}

@article{burr_recent_2016,
	title = {Recent {Progress} in {Phase}-{Change} {Memory} {Technology}},
	volume = {6},
	issn = {2156-3357},
	doi = {10.1109/JETCAS.2016.2547718},
	journal = {IEEE Journal on Emerging and Selected Topics in Circuits and Systems},
	author = {Burr, G. W. and Brightsky, M. J. and Sebastian, A. and Cheng, H. Y. and Wu, J. Y. and Kim, S. and Sosa, N. E. and Papandreou, N. and Lung, H. L. and Pozidis, H. and Eleftheriou, E. and Lam, C. H.},
	month = jun,
	year = {2016},
	pages = {146--162}
}

@misc{ wiki_cd_rw,
    author = {{Wikipedia contributors}},
    title = {CD-RW --- {Wikipedia}{,} The Free Encyclopedia},
    year = {2018},
    url = {https://en.wikipedia.org/w/index.php?title=CD-RW&oldid=857603659},
    note = {[Online; accessed 15-October-2018]}
  }

@misc{shimpi_intels_2008,
	title = {Intel's 8-core {Skulltrail} {Platform}: {Close} to {Perfecting} the {Niche}},
	url = {https://www.anandtech.com/show/2435/3},
	journal = {Anandtech},
	author = {Shimpi, Anand Lal},
	month = feb,
	year = {2008}
}

@incollection{grid5000,
	title = {Adding Virtualization Capabilities to the {Grid'5000} Testbed},
	author = {Balouek, Daniel and Carpen Amarie, Alexandra and Charrier, Ghislain and Desprez, Fr{\'e}d{\'e}ric and Jeannot, Emmanuel and Jeanvoine, Emmanuel and L{\`e}bre, Adrien and Margery, David and Niclausse, Nicolas and Nussbaum, Lucas and Richard, Olivier and P{\'e}rez, Christian and Quesnel, Flavien and Rohr, Cyril and Sarzyniec, Luc},
	booktitle = {Cloud Computing and Services Science},
	publisher = {Springer International Publishing},
	pages = {3-20},
	volume = {367},
	editor = {Ivanov, Ivan I. and van Sinderen, Marten and Leymann, Frank and Shan, Tony },
	series = {Communications in Computer and Information Science },
	isbn = {978-3-319-04518-4 },
	doi = {10.1007/978-3-319-04519-1\_1 },
	year = {2013},
}

@inproceedings{desrochers_validation_2016,
	title = {A {Validation} of {DRAM} {RAPL} {Power} {Measurements}},
	isbn = {978-1-4503-4305-3},
	url = {http://dl.acm.org/citation.cfm?doid=2989081.2989088},
	doi = {10.1145/2989081.2989088},
	language = {en},
	urldate = {2017-09-22},
	publisher = {ACM Press},
	author = {Desrochers, Spencer and Paradis, Chad and Weaver, Vincent M.},
	year = {2016},
	pages = {455--470}
}

@inproceedings{david_rapl_2010,
	title = {{RAPL}: memory power estimation and capping},
	isbn = {978-1-4503-0146-6},
	shorttitle = {{RAPL}},
	url = {http://portal.acm.org/citation.cfm?doid=1840845.1840883},
	doi = {10.1145/1840845.1840883},
	language = {en},
	urldate = {2018-01-16},
	publisher = {ACM Press},
	author = {David, Howard and Gorbatov, Eugene and Hanebutte, Ulf R. and Khanaa, Rahul and Le, Christian},
	year = {2010},
	pages = {189}
}

@article{hahnel_measuring_2012,
	title = {Measuring energy consumption for short code paths using {RAPL}},
	volume = {40},
	issn = {01635999},
	url = {http://dl.acm.org/citation.cfm?doid=2425248.2425252},
	doi = {10.1145/2425248.2425252},
	language = {en},
	number = {3},
	urldate = {2018-01-19},
	journal = {ACM SIGMETRICS Performance Evaluation Review},
	author = {Hähnel, Marcus and Döbel, Björn and Völp, Marcus and Härtig, Hermann},
	month = jan,
	year = {2012},
	pages = {13}
}

@article{khan_rapl_2018,
	title = {{RAPL} in {Action}: {Experiences} in {Using} {RAPL} for {Power} {Measurements}},
	volume = {3},
	issn = {23763639},
	shorttitle = {{RAPL} in {Action}},
	url = {http://dl.acm.org/citation.cfm?doid=3199681.3177754},
	doi = {10.1145/3177754},
	language = {en},
	number = {2},
	urldate = {2018-03-30},
	journal = {ACM Transactions on Modeling and Performance Evaluation of Computing Systems},
	author = {Khan, Kashif Nizam and Hirki, Mikael and Niemi, Tapio and Nurminen, Jukka K. and Ou, Zhonghong},
	month = mar,
	year = {2018},
	pages = {1--26}
}

@inproceedings{hackenberg_energy_2015,
	address = {Hyderabad, India},
	title = {An {Energy} {Efficiency} {Feature} {Survey} of the {Intel} {Haswell} {Processor}},
	isbn = {978-1-4673-7684-6},
	url = {http://ieeexplore.ieee.org/document/7284406/},
	doi = {10.1109/IPDPSW.2015.70},
	urldate = {2018-09-21},
	booktitle = {2015 {IEEE} {International} {Parallel} and {Distributed} {Processing} {Symposium} {Workshop}},
	publisher = {IEEE},
	author = {Hackenberg, Daniel and Schone, Robert and Ilsche, Thomas and Molka, Daniel and Schuchart, Joseph and Geyer, Robin},
	month = may,
	year = {2015},
	pages = {896--904}
}

@misc{hardkernel_odroid_xu3_2014,
	title = {{ODROID}-{XU}3},
	url = {https://www.hardkernel.com/main/products/prdt_info.php?g_code=G140448267127&tab_idx=2},
	author = {{Hardkernel}},
	year = {2014}
}

@techreport{amlogic_s905x_2017,
	title = {S905X {Datasheet}},
	author = {{Amlogic}},
	month = mar,
	year = {2017},
	file = {S905X.pdf:/home/francis/.zotero/zotero/0cj1dqaw.default/zotero/storage/S6C3QU3N/S905X.pdf:application/pdf}
}

@techreport{amlogic_s912_2017,
	title = {S912 {Datasheet}},
	author = {{Amlogic}},
	month = mar,
	year = {2017},
	file = {S912.pdf:/home/francis/.zotero/zotero/0cj1dqaw.default/zotero/storage/XZSM5CZZ/S912.pdf:application/pdf}
}

@techreport{intel_7th_2018,
	title = {7th {Generation} {Intel} ®  {Processor}  {Famil} y  for {U}/{Y} {Platforms} and 8th  {Generation} {Intel} ®  {Processor} {Family}  for {U} {Quad} {Core} {Platforms} {Da} tasheet, {Volume} 1 of 2},
	url = {https://www.intel.com/content/dam/www/public/us/en/documents/datasheets/7th-gen-core-family-mobile-u-y-processor-lines-datasheet-vol-1.pdf},
	author = {{Intel}},
	month = sep,
	year = {2018},
	pages = {214},
	file = {Intel - 2018 - 7th Generation Intel ®  Processor  Famil y  for U.pdf:/home/francis/.zotero/zotero/0cj1dqaw.default/zotero/storage/7ZN5B2UE/Intel - 2018 - 7th Generation Intel ®  Processor  Famil y  for U.pdf:application/pdf}
}

@techreport{intel_7th_2017,
	title = {7th {Generation} {Intel} ®  {Processor}  {Famil} y  for {U}/{Y} {Platforms} and 8th  {Generation} {Intel} ®  {Processor} {Family}  for {U} {Quad} {Core} {Platforms} {Da} tasheet, {Volume} 2 of 2},
	url = {https://www.intel.com/content/dam/www/public/us/en/documents/datasheets/7th-gen-core-family-mobile-u-y-processor-lines-datasheet-vol-2.pdf},
	author = {{Intel}},
	month = aug,
	year = {2017},
	pages = {311},
	file = {Intel - 2017 - 7th Generation Intel ®  Processor  Famil y  for U.pdf:/home/francis/.zotero/zotero/0cj1dqaw.default/zotero/storage/LZYLLWIR/Intel - 2017 - 7th Generation Intel ®  Processor  Famil y  for U.pdf:application/pdf}
}

@misc{optane,
	title = {Technologie {Intel}® {Optane}™},
	author = {{Intel}},
	year = {2017}
}

@misc{sysconf,
	title = {Constants for sysconf {Parameters}},
	url = {https://www.gnu.org/software/libc/manual/html_node/Constants-for-Sysconf.html},
	author = {{GNU}}
}

@misc{laniel_g5kminperlapi_2018,
	title = {G5KMinPerlAPI},
	url = {https://gitlab.com/eiffel/G5KMinPerlAPI},
	author = {Laniel, Francis},
	year = {2018}
}

@misc{amazon_amazon_nodate,
	title = {Amazon {Elastic} {Container} {Service}},
	url = {https://aws.amazon.com/ecs/?nc1=h_ls},
	author = {{Amazon}}
}

@misc{microsoft_microsoft_nodate,
	title = {Microsoft {Web} {App} for {Containers}},
	url = {https://azure.microsoft.com/en-us/services/app-service/containers/},
	author = {{Microsoft}}
}

@misc{alibaba_alibaba_nodate,
	title = {Alibaba {Container} {Service}},
	url = {https://www.alibabacloud.com/product/container-service?spm=a2c5t.10695662.1996646101.searchclickresult.55a3212bnXyv1v},
	author = {{Alibaba}}
}

@misc{ovh_ovh_nodate,
	title = {{OVH} {Kubernetes}},
	url = {https://www.ovh.com/fr/kubernetes/},
	author = {{OVH}}
}

@misc{docker_what_nodate,
	title = {What is a {Container}?},
	url = {https://www.docker.com/resources/what-container},
	author = {{Docker}}
}

@misc{docker_docker_nodate,
	title = {Docker {CE}},
	url = {https://github.com/docker/docker-ce},
	author = {{Docker}}
}

@misc{porterie_docker_2016,
	title = {Docker 1.11: {The} first runtime built on containerd and based on {OCI} technology},
	url = {https://blog.docker.com/2016/04/docker-engine-1-11-runc/},
	journal = {Docker blog},
	author = {Porterie, Arnaud},
	month = apr,
	year = {2016}
}

@misc{docker_docker_nodate-1,
	title = {Docker {CLI}},
	url = {https://github.com/docker/cli},
	author = {{Docker}}
}

@misc{noauthor_moby_nodate,
	title = {Moby},
	url = {https://github.com/moby/moby}
}

@misc{crosby_what_2017,
	title = {What is containerd ?},
	url = {https://blog.docker.com/2017/08/what-is-containerd-runtime/},
	journal = {Docker blog},
	author = {Crosby, Michael},
	month = aug,
	year = {2017}
}

@misc{docker_core_engineering_docker_2016,
	title = {Docker 1.12: {Now} with {Built}-in {Orchestration}!},
	url = {https://blog.docker.com/2016/06/docker-1-12-built-in-orchestration/},
	author = {{Docker Core Engineering}},
	month = jun,
	year = {2016}
}

@misc{containerd_containerd_nodate,
	title = {containerd},
	url = {https://github.com/containerd/containerd},
	author = {{containerd}}
}

@misc{docker_hub,
	title = {Docker {Hub}},
	url = {https://hub.docker.com/},
	author = {{Docker}}
}

@misc{hykes_introducing_2015,
	title = {Introducing {runC}: a lightweight universal container runtime},
	journal = {Docker blog},
	author = {Hykes, Solomon},
	month = jun,
	year = {2015}
}

@misc{opencontainers_runc_nodate,
	title = {runc},
	url = {https://github.com/opencontainers/runc},
	author = {{opencontainers}}
}

@misc{kerrisk_lce_2012,
	title = {{LCE}: {The} failure of operating systems and how we can fix it},
	url = {https://lwn.net/Articles/524952/},
	journal = {LWN},
	author = {Kerrisk, Michael},
	month = nov,
	year = {2012}
}

@misc{hiroyu_cgroup_2008,
	title = {Cgroup {And} {Memory} {Resource}  {Controller}},
	url = {https://www.static.linuxfound.org/jp_uploads/seminar20081119/CgroupMemcgMaster.pdf},
	author = {Hiroyu, Kamezawa},
	month = nov,
	year = {2008}
}

@misc{linux_memory_nodate,
	title = {Memory {Resource} {Controller}},
	url = {https://www.kernel.org/doc/Documentation/cgroup-v1/memory.txt},
	author = {{Linux}}
}

@misc{alexey_kopytov_sysbench_nodate,
	title = {sysbench},
	author = {{Alexey Kopytov}}
}

@misc{intel_intel_2012,
	title = {Intel® {Xeon}® {Processor} {E}5-1603},
	url = {https://ark.intel.com/content/www/us/en/ark/products/64600/intel-xeon-processor-e5-1603-10m-cache-2-80-ghz-0-0-gt-s-intel-qpi.html},
	author = {{Intel}},
	year = {2012}
}

@misc{barr_new_2018,
	title = {New {AWS} {Auto} {Scaling} – {Unified} {Scaling} {For} {Your} {Cloud} {Applications}},
	url = {https://aws.amazon.com/fr/blogs/aws/aws-auto-scaling-unified-scaling-for-your-cloud-applications/},
	journal = {AWS News Blog},
	author = {Barr, Jeff},
	month = jan,
	year = {2018}
}

@misc{noauthor_microsoft_2017,
	title = {Microsoft {Azure}: {Autoscaling}},
	url = {https://docs.microsoft.com/en-us/azure/architecture/best-practices/auto-scaling},
	journal = {Microsoft Azure},
	month = may,
	year = {2017}
}

@misc{noauthor_google_2018,
	title = {Google {Cloud} : Équilibrage de charge et scaling},
	url = {https://cloud.google.com/compute/docs/load-balancing-and-autoscaling#policies},
	month = dec,
	year = {2018}
}

@misc{noauthor_kubernetes_autoscaler_2019,
	title = {kubernetes/autoscaler},
	url = {https://github.com/kubernetes/autoscaler/blob/master/cluster-autoscaler/FAQ.md},
	month = feb,
	year = {2019}
}

@techreport{amazon_aws_2018,
	title = {{AWS} {Auto} {Scaling} {Guide} de l'utilisateur},
	url = {https://docs.aws.amazon.com/fr_fr/autoscaling/plans/userguide/as-plans-ug.pdf#auto-scaling-getting-started},
	author = {{Amazon}},
	month = nov,
	year = {2018},
	pages = {23}
}

@inproceedings{kim_dynamic_2015,
	address = {Washington DC, DC, USA},
	title = {Dynamic {Memory} {Pressure} {Aware} {Ballooning}},
	isbn = {978-1-4503-3604-8},
	url = {http://dl.acm.org/citation.cfm?doid=2818950.2818967},
	doi = {10.1145/2818950.2818967},
	language = {en},
	urldate = {2019-03-12},
	booktitle = {Proceedings of the 2015 {International} {Symposium} on {Memory} {Systems} - {MEMSYS} '15},
	publisher = {ACM Press},
	author = {Kim, Jinchun and Fedorov, Viacheslav and Gratz, Paul V. and Reddy, A. L. Narasimha},
	year = {2015},
	pages = {103--112}
}

@inproceedings{salomie_application_2013,
	address = {Prague, Czech Republic},
	title = {Application level ballooning for efficient server consolidation},
	isbn = {978-1-4503-1994-2},
	url = {http://dl.acm.org/citation.cfm?doid=2465351.2465384},
	doi = {10.1145/2465351.2465384},
	language = {en},
	urldate = {2019-03-12},
	booktitle = {Proceedings of the 8th {ACM} {European} {Conference} on {Computer} {Systems} - {EuroSys} '13},
	publisher = {ACM Press},
	author = {Salomie, Tudor-Ioan and Alonso, Gustavo and Roscoe, Timothy and Elphinstone, Kevin},
	year = {2013},
	pages = {337}
}

@misc{kvm_automatic_2013,
	title = {Automatic {Ballooning}},
	url = {https://www.linux-kvm.org/page/Projects/auto-ballooning},
	author = {{KVM}},
	year = {2013}
}

@misc{capitulino_automatic_2013,
	title = {Automatic ballooning},
	url = {https://www.linux-kvm.org/images/5/58/Kvm-forum-2013-automatic-ballooning.pdf},
	author = {Capitulino, Luiz},
	month = oct,
	year = {2013}
}

@article{lorido_botran_review_2014,
	title = {A {Review} of {Auto}-scaling {Techniques} for {Elastic} {Applications} in {Cloud} {Environments}},
	volume = {12},
	issn = {1570-7873, 1572-9184},
	url = {http://link.springer.com/10.1007/s10723-014-9314-7},
	doi = {10.1007/s10723-014-9314-7},
	language = {en},
	number = {4},
	urldate = {2019-02-26},
	journal = {Journal of Grid Computing},
	author = {Lorido-Botran, Tania and Miguel-Alonso, Jose and Lozano, Jose A.},
	month = dec,
	year = {2014},
	pages = {559--592}
}

@inproceedings{rao_distributed_2011,
	address = {Singapore, Singapore},
	title = {A {Distributed} {Self}-{Learning} {Approach} for {Elastic} {Provisioning} of {Virtualized} {Cloud} {Resources}},
	isbn = {978-1-4577-0468-0},
	url = {http://ieeexplore.ieee.org/document/6005367/},
	doi = {10.1109/MASCOTS.2011.47},
	urldate = {2019-02-26},
	booktitle = {2011 {IEEE} 19th {Annual} {International} {Symposium} on {Modelling}, {Analysis}, and {Simulation} of {Computer} and {Telecommunication} {Systems}},
	publisher = {IEEE},
	author = {Rao, Jia and Bu, Xiangping and Xu, Cheng-Zhong and Wang, Kun},
	month = jul,
	year = {2011},
	pages = {45--54}
}

@inproceedings{moore_transforming_2013,
	address = {Prague, Czech Republic},
	title = {Transforming reactive auto-scaling into proactive auto-scaling},
	isbn = {978-1-4503-2075-7},
	url = {http://dl.acm.org/citation.cfm?doid=2460756.2460758},
	doi = {10.1145/2460756.2460758},
	language = {en},
	urldate = {2019-02-26},
	booktitle = {Proceedings of the 3rd {International} {Workshop} on {Cloud} {Data} and {Platforms} - {CloudDP} '13},
	publisher = {ACM Press},
	author = {Moore, Laura R. and Bean, Kathryn and Ellahi, Tariq},
	year = {2013},
	pages = {7--12}
}

@inproceedings{kriushanth_load_2015,
	address = {Coimbatore, India},
	title = {Load balancer behavior identifier ({LoBBI}) for dynamic threshold based auto-scaling in cloud},
	isbn = {978-1-4799-6804-6 978-1-4799-6805-3},
	url = {http://ieeexplore.ieee.org/document/7218115/},
	doi = {10.1109/ICCCI.2015.7218115},
	urldate = {2019-02-26},
	booktitle = {2015 {International} {Conference} on {Computer} {Communication} and {Informatics} ({ICCCI})},
	publisher = {IEEE},
	author = {Kriushanth, M. and Arockiam, L.},
	month = jan,
	year = {2015},
	pages = {1--5}
}

@inproceedings{kim_dynamic_2015,
	address = {Washington DC, DC, USA},
	title = {Dynamic {Memory} {Pressure} {Aware} {Ballooning}},
	isbn = {978-1-4503-3604-8},
	url = {http://dl.acm.org/citation.cfm?doid=2818950.2818967},
	doi = {10.1145/2818950.2818967},
	language = {en},
	urldate = {2019-03-12},
	booktitle = {Proceedings of the 2015 {International} {Symposium} on {Memory} {Systems} - {MEMSYS} '15},
	publisher = {ACM Press},
	author = {Kim, Jinchun and Fedorov, Viacheslav and Gratz, Paul V. and Reddy, A. L. Narasimha},
	year = {2015},
	pages = {103--112}
}

@inproceedings{salomie_application_2013,
	address = {Prague, Czech Republic},
	title = {Application level ballooning for efficient server consolidation},
	isbn = {978-1-4503-1994-2},
	url = {http://dl.acm.org/citation.cfm?doid=2465351.2465384},
	doi = {10.1145/2465351.2465384},
	language = {en},
	urldate = {2019-03-12},
	booktitle = {Proceedings of the 8th {ACM} {European} {Conference} on {Computer} {Systems} - {EuroSys} '13},
	publisher = {ACM Press},
	author = {Salomie, Tudor-Ioan and Alonso, Gustavo and Roscoe, Timothy and Elphinstone, Kevin},
	year = {2013},
	pages = {337}
}

@misc{kvm_automatic_2013,
	title = {Automatic {Ballooning}},
	url = {https://www.linux-kvm.org/page/Projects/auto-ballooning},
	author = {{KVM}},
	year = {2013}
}

@misc{capitulino_automatic_2013,
	title = {Automatic ballooning},
	url = {https://www.linux-kvm.org/images/5/58/Kvm-forum-2013-automatic-ballooning.pdf},
	author = {Capitulino, Luiz},
	month = oct,
	year = {2013}
}

@misc{qemu_qemu_2019,
	title = {Qemu},
	url = {https://wiki.archlinux.org/index.php/QEMU},
	language = {English},
	author = {{Qemu}},
	month = may,
	year = {2019}
}

@inproceedings{carver_acdc_2017,
	address = {Cambridge, MA},
	title = {{ACDC}: {Advanced} consolidation for dynamic containers},
	isbn = {978-1-5386-1465-5},
	shorttitle = {{ACDC}},
	url = {http://ieeexplore.ieee.org/document/8171363/},
	doi = {10.1109/NCA.2017.8171363},
	urldate = {2019-05-22},
	booktitle = {2017 {IEEE} 16th {International} {Symposium} on {Network} {Computing} and {Applications} ({NCA})},
	publisher = {IEEE},
	author = {Carver, Damien and Sopena, Julien and Monnet, Sebastien},
	month = oct,
	year = {2017},
	pages = {1--8}
}

@book{gorman_understanding_2004,
	address = {Upper Saddle River, NJ},
	series = {Bruce {Perens}' open source series},
	title = {Understanding the {Linux} {Virtual} {Memory} {Manager}: finally, a fast, efficient way to master the {Linux} {VM}! ; fully illustrated tutorials on {VM} architecture and all {VM} algorithms ; line-by-line commentary on all the core {VM} code ; physical memory description, page tables, address spaces, allocation, slabs, high memory, swapping, shared memory, out-of-memory management, and more ; complete {VM} {Learning} {Lab} on {CD}-{ROM}: browsable kernel source, call graph generator, analysis/benchmarking tools, and code commentary},
	isbn = {978-0-13-145348-7},
	shorttitle = {Understanding the {Linux} {Virtual} {Memory} {Manager}},
	language = {eng},
	publisher = {Prentice Hall},
	author = {Gorman, Mel},
	year = {2004},
	note = {OCLC: 834670086}
}

@inproceedings{david_memory_2011,
	address = {New York, NY, USA},
	series = {{ICAC} '11},
	title = {Memory {Power} {Management} via {Dynamic} {Voltage}/{Frequency} {Scaling}},
	isbn = {978-1-4503-0607-2},
	url = {http://doi.acm.org/10.1145/1998582.1998590},
	doi = {10.1145/1998582.1998590},
	abstract = {Energy efficiency and energy-proportional computing have become a central focus in enterprise server architecture. As thermal and electrical constraints limit system power, and datacenter operators become more conscious of energy costs, energy efficiency becomes important across the whole system. There are many proposals to scale energy at the datacenter and server level. However, one significant component of server power, the memory system, remains largely unaddressed. We propose memory dynamic volt age/frequency scaling (DVFS) to address this problem, and evaluate a simple algorithm in a real system. As we show, in a typical server platform, memory consumes 19\% of system power on average while running SPEC CPU2006 workloads. While increasing core counts demand more bandwidth and drive the memory frequency upward, many workloads require much less than peak bandwidth. These workloads suffer minimal performance impact when memory frequency is reduced. When frequency reduces, voltage can be reduced as well. We demonstrate a large opportunity for memory power reduction with a simple control algorithm that adjusts memory voltage and frequency based on memory bandwidth utilization. We evaluate memory DVFS in a real system, emulating reduced memory frequency by altering timing registers and using an analytical model to compute power reduction. With an average of 0.17\% slowdown, we show 10.4\% average (20.5\% max) memory power reduction, yielding 2.4\% average (5.2\% max) whole-system energy improvement.},
	urldate = {2017-04-27},
	booktitle = {Proceedings of the 8th {ACM} {International} {Conference} on {Autonomic} {Computing}},
	publisher = {ACM},
	author = {David, Howard and Fallin, Chris and Gorbatov, Eugene and Hanebutte, Ulf R. and Mutlu, Onur},
	year = {2011},
	keywords = {DRAM, dvfs, energy efficiency, memory},
	pages = {31--40}
}

@inproceedings{huang_design_2003,
	title = {Design and {Implementation} of {Power}-{Aware} {Virtual} {Memory}},
	url = {https://www.usenix.org/legacy/events/usenix03/tech/full_papers/full_papers/huang/huang.pdf},
	author = {Huang, Hai and Pillai, Padmanabhan and Shin, Kang},
	month = feb,
	year = {2003}
}

@article{jantz_framework_2013,
	title = {A framework for application guidance in virtual memory systems},
	volume = {48},
	issn = {03621340},
	url = {http://dl.acm.org/citation.cfm?doid=2517326.2451543},
	doi = {10.1145/2517326.2451543},
	language = {en},
	number = {7},
	urldate = {2018-07-24},
	journal = {ACM SIGPLAN Notices},
	author = {Jantz, Michael R. and Strickland, Carl and Kumar, Karthik and Dimitrov, Martin and Doshi, Kshitij A.},
	month = aug,
	year = {2013},
	pages = {155}
}